# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class CustomerBalanceTransactionType(str, enum.Enum):
    """
    refer https://stripe.com/docs/billing/customer/balance#types
    """

    ADJUSTMENT = "adjustment"
    APPLIED_TO_INVOICE = "applied_to_invoice"
    CREDIT_NOTE = "credit_note"
    INITIAL = "initial"
    INVOICE_OVERPAID = "invoice_overpaid"
    INVOICE_TOO_LARGE = "invoice_too_large"
    INVOICE_TOO_SMALL = "invoice_too_small"
    UNSPENT_RECEIVER_CREDIT = "unspent_receiver_credit"
    UNAPPLIED_FROM_INVOICE = "unapplied_from_invoice"

    def visit(
        self,
        adjustment: typing.Callable[[], T_Result],
        applied_to_invoice: typing.Callable[[], T_Result],
        credit_note: typing.Callable[[], T_Result],
        initial: typing.Callable[[], T_Result],
        invoice_overpaid: typing.Callable[[], T_Result],
        invoice_too_large: typing.Callable[[], T_Result],
        invoice_too_small: typing.Callable[[], T_Result],
        unspent_receiver_credit: typing.Callable[[], T_Result],
        unapplied_from_invoice: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is CustomerBalanceTransactionType.ADJUSTMENT:
            return adjustment()
        if self is CustomerBalanceTransactionType.APPLIED_TO_INVOICE:
            return applied_to_invoice()
        if self is CustomerBalanceTransactionType.CREDIT_NOTE:
            return credit_note()
        if self is CustomerBalanceTransactionType.INITIAL:
            return initial()
        if self is CustomerBalanceTransactionType.INVOICE_OVERPAID:
            return invoice_overpaid()
        if self is CustomerBalanceTransactionType.INVOICE_TOO_LARGE:
            return invoice_too_large()
        if self is CustomerBalanceTransactionType.INVOICE_TOO_SMALL:
            return invoice_too_small()
        if self is CustomerBalanceTransactionType.UNSPENT_RECEIVER_CREDIT:
            return unspent_receiver_credit()
        if self is CustomerBalanceTransactionType.UNAPPLIED_FROM_INVOICE:
            return unapplied_from_invoice()
