# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class PaymentProcessorName(str, enum.Enum):
    """
    PaymentProcessors are api's that we support and can charge.
    """

    BRAINTREE = "braintree"
    STRIPE = "stripe"
    AUTHORIZE_NET = "authorize_net"

    def visit(
        self,
        braintree: typing.Callable[[], T_Result],
        stripe: typing.Callable[[], T_Result],
        authorize_net: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is PaymentProcessorName.BRAINTREE:
            return braintree()
        if self is PaymentProcessorName.STRIPE:
            return stripe()
        if self is PaymentProcessorName.AUTHORIZE_NET:
            return authorize_net()
