# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from ..core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from ..core.unchecked_base_model import UncheckedBaseModel
from .object_name import ObjectName


class SubscriptionItemExternal(UncheckedBaseModel):
    id: str = pydantic_v1.Field()
    """
    Unique Identifier of the subscription_item.
    """

    object: typing.Optional[ObjectName] = None
    created_at: dt.datetime = pydantic_v1.Field()
    """
    DateTime at which the object was created, in 'ISO 8601' format.
    """

    updated_at: dt.datetime = pydantic_v1.Field()
    """
    DateTime at which the object was updated, in 'ISO 8601' format.
    """

    is_deleted: typing.Optional[bool] = pydantic_v1.Field(default=None)
    """
    If true, indicates that this object has been deleted
    """

    subscription_id: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    Unique Identifier of the subscription.
    """

    pending_attachment_to_subscription_id: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    Unique Identifier of the subscription in which this itemwill be included upon renewal.
    """

    price_id: str = pydantic_v1.Field()
    """
    Unique Identifier of the customer.
    """

    quantity: int = pydantic_v1.Field()
    """
    Quantity of the product selected for the subscription_item.
    """

    deleted_at: typing.Optional[dt.datetime] = pydantic_v1.Field(default=None)
    """
    If deleted, then this is the 'ISO 8601' it was deleted
    """

    drop_at_end: bool = pydantic_v1.Field()
    """
    Whether or not this item will be dropped from subscription before next renewal
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
